//----------------------------------------------------------------------//
// ėppW[													//
//																		//
//----------------------------------------------------------------------//
#ifndef UserMdlH
#define UserMdlH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.Actions.hpp>
#include <System.ImageList.hpp>
#include <Vcl.ActnList.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.ExtDlgs.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.Menus.hpp>
#include <Vcl.StdActns.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.ImgList.hpp>
#include "usr_scrpanel.h"

//---------------------------------------------------------------------------
//Xg{bNX̃IvV^O
#define LBTAG_OPT_FOCS	0x10000000		//AXg{bNXɃtH[JX
#define LBTAG_OPT_INHI	0x20000000		//ύX֎~

//R{{bNX̃IvV^O
#define CBTAG_RGEX_V	0x10000000		//K\QƂ\
#define CBTAG_RGEX_E	0x20000000		//K\QƂL
#define CBTAG_HISTORY	0x40000000		//
#define CBTAG_NO_CALC	0x80000000		//d\Ȃ

//GfBbg{bNX̃IvV^O
#define EDTAG_RGEX_V	0x10000000		//K\QƂ\
#define EDTAG_RGEX_E	0x20000000		//K\QƂL
#define EDTAG_DST_FMT	0x40000000		//ȔQ
#define EDTAG_NO_CALC	0x80000000		//d\Ȃ

//t@C_CAOptB^
#define F_FILTER_EXE	_T("st@C (*.exe)|*.EXE")
#define F_FILTER_EXE2	_T("st@C (*.exe)|*.EXE|V[gJbg (*.lnk)|*.LNK")
#define F_FILTER_NBT	_T("R}ht@C(*.nbt)|*.NBT")
#define F_FILTER_INI	_T("ݒt@C (*.ini)|*.INI")
#define F_FILTER_TXT	_T("eLXgt@C (*.txt)|*.TXT")
#define F_FILTER_CSV	_T("CSVt@C (*.csv)|*.CSV")
#define F_FILTER_TSV	_T("TSVt@C (*.txt,*.csv,*.tsv)|*.TXT;*.CSV;*.TSV")
#define F_FILTER_NWL	_T("[NXg (*.nwl)|*.nwl")
#define F_FILTER_ICO	_T("(*.ico,*.exe,*.dll,*.lnk)|*.ICO;*.EXE;*.DLL;*.LNK")
#define F_FILTER_WAV	_T("WAVt@C|*.WAV|ׂẴt@C(*.*)|*.*")
#define F_FILTER_ALL	_T("ׂẴt@C(*.*)|*.*")

//R[hy[W
struct code_page_inf {
	unsigned int  page;
	UnicodeString name;
};

#define MAX_SAVE_CODEPAGES 6
extern code_page_inf SaveCodePages[MAX_SAVE_CODEPAGES];

//---------------------------------------------------------------------------
class TUserModule : public TDataModule
{
__published:	// IDE ŊǗR|[lg
	TAction *CalculatorAction;
	TAction *ClrHistComboAction;
	TAction *ClrListItemAction;
	TAction *CopyComboAction;
	TAction *CutComboAction;
	TAction *DelHistComboAction;
	TAction *DelListItemAction;
	TAction *DownListItemAction;
	TAction *PasteComboAction;
	TAction *RefCmdNameAction;
	TAction *RefCurFNameAction;
	TAction *RefCurPathAction;
	TAction *RefCurPNameAction;
	TAction *RefOppPathAction;
	TAction *RegExCheckerAction;
	TAction *RenInsNameAction;
	TAction *SelAllComboAction;
	TAction *SizePosToFlieListAction;
	TAction *UpListItemAction;
	TActionList *CommonActList;
	TColorDialog *ColorDlg;
	TEditCopy *EditCopy1;
	TEditCut *EditCut1;
	TEditDelete *EditDelete1;
	TEditPaste *EditPaste1;
	TEditSelectAll *EditSelectAll1;
	TEditUndo *EditUndo1;
	TFontDialog *FontDlg;
	TMenuItem *CalculatorEItem;
	TMenuItem *CalculatorItem;
	TMenuItem *ClrHistItem;
	TMenuItem *DelHistItem;
	TMenuItem *GrepCopyItem;
	TMenuItem *GrepCutItem;
	TMenuItem *GrepPasteItem;
	TMenuItem *PopAllSelItem;
	TMenuItem *PopCopyItem;
	TMenuItem *PopCurFnamItem;
	TMenuItem *PopCurPathItem;
	TMenuItem *PopCutItem;
	TMenuItem *PopDelItem;
	TMenuItem *PopDFmt01Item;
	TMenuItem *PopDFmt02Item;
	TMenuItem *PopDFmt03Item;
	TMenuItem *PopDFmt04Item;
	TMenuItem *PopDFmt05Item;
	TMenuItem *PopDFmt06Item;
	TMenuItem *PopDFmt07Item;
	TMenuItem *PopDFmt08Item;
	TMenuItem *PopDFmt09Item;
	TMenuItem *PopOppPathItem;
	TMenuItem *PopPasteItem;
	TMenuItem *PopRefCmdItem;
	TMenuItem *PopRefFmtItem;
	TMenuItem *PopUndoItem;
	TMenuItem *RefCmdItem;
	TMenuItem *RefCurFnamItem;
	TMenuItem *RefCurPnamItem;
	TMenuItem *RegExChkEItem;
	TMenuItem *RegExChkItem;
	TMenuItem *RegExpEItem;
	TMenuItem *RegExpItem;
	TMenuItem *RenInputNameItem;
	TMenuItem *SelAllItem;
	TMenuItem *Sep_e_1;
	TMenuItem *Sep_e_2;
	TMenuItem *Sep_e_3;
	TMenuItem *Sep_e_4;
	TMenuItem *Sep_g_1;
	TMenuItem *Sep_g_2;
	TMenuItem *Sep_g_3;
	TOpenDialog *OpenDlg;
	TOpenPictureDialog *OpenImgDlg;
	TPopupMenu *EditPopupMenu;
	TPopupMenu *EditPopupMenuE;
	TSaveDialog *SaveDlg;
	TSaveTextFileDialog *SaveTxtDlg;
	TTimer *ScrollTimer;
	TTimer *SpuitTimer;

	void __fastcall DataModuleCreate(TObject *Sender);
	void __fastcall UpListItemActionExecute(TObject *Sender);
	void __fastcall UpListItemActionUpdate(TObject *Sender);
	void __fastcall DownListItemActionExecute(TObject *Sender);
	void __fastcall DownListItemActionUpdate(TObject *Sender);
	void __fastcall DelListItemActionExecute(TObject *Sender);
	void __fastcall DelListItemActionUpdate(TObject *Sender);
	void __fastcall ClrListItemActionExecute(TObject *Sender);
	void __fastcall ClrListItemActionUpdate(TObject *Sender);
	void __fastcall SpuitTimerTimer(TObject *Sender);

	void __fastcall CutComboActionExecute(TObject *Sender);
	void __fastcall EditComboActionUpdate(TObject *Sender);
	void __fastcall CopyComboActionExecute(TObject *Sender);
	void __fastcall PasteComboActionExecute(TObject *Sender);
	void __fastcall PasteComboActionUpdate(TObject *Sender);

	void __fastcall FileDlgClose(TObject *Sender);
	void __fastcall DelHistComboActionExecute(TObject *Sender);
	void __fastcall DelHistComboActionUpdate(TObject *Sender);
	void __fastcall ClrHistComboActionExecute(TObject *Sender);
	void __fastcall ClrHistComboActionUpdate(TObject *Sender);
	void __fastcall EditPopupMenuPopup(TObject *Sender);
	void __fastcall RefRegExItemClick(TObject *Sender);
	void __fastcall SelAllComboActionExecute(TObject *Sender);
	void __fastcall SelAllComboActionUpdate(TObject *Sender);
	void __fastcall RefCmdNameActionExecute(TObject *Sender);
	void __fastcall RefCmdNameActionUpdate(TObject *Sender);
	void __fastcall RefCurPathActionExecute(TObject *Sender);
	void __fastcall RefCurPathActionUpdate(TObject *Sender);
	void __fastcall RefOppPathActionExecute(TObject *Sender);
	void __fastcall RefOppPathActionUpdate(TObject *Sender);
	void __fastcall RefCurFNameActionExecute(TObject *Sender);
	void __fastcall RefCurFNameActionUpdate(TObject *Sender);
	void __fastcall RefCurPNameActionExecute(TObject *Sender);
	void __fastcall RefCurPNameActionUpdate(TObject *Sender);
	void __fastcall EditPopupMenuEPopup(TObject *Sender);
	void __fastcall EditPaste1Execute(TObject *Sender);
	void __fastcall PopDFmtItemClick(TObject *Sender);
	void __fastcall ScrollTimerTimer(TObject *Sender);
	void __fastcall RegExCheckerActionExecute(TObject *Sender);
	void __fastcall RegExCheckerActionUpdate(TObject *Sender);
	void __fastcall DataModuleDestroy(TObject *Sender);
	void __fastcall CalculatorActionExecute(TObject *Sender);
	void __fastcall CalculatorActionUpdate(TObject *Sender);
	void __fastcall SizePosToFlieListActionExecute(TObject *Sender);

private:	// [U[錾
	TCustomListBox *ActiveListBox;		//ΏۃXg{bNX
	UsrScrollPanel *ActiveScrPanel;		//VvXN[o[
	int PrevListIdx;

	TPanel *SpuitPanel;
	TImage *SpuitImage;

	void __fastcall ListBoxStartDrag(TObject *Sender, TDragObject *&DragObject);
	void __fastcall ListBoxDragOver(TObject *Sender, TObject *Source, int X, int Y,
			TDragState State, bool &Accept);
	void __fastcall ListBoxDragDrop(TObject *Sender, TObject *Source, int X, int Y);
	void __fastcall ListBoxEndDrag(TObject *Sender, TObject *Target, int X, int Y);

	TComboBox*    __fastcall GetActiveComboBox();
	TLabeledEdit* __fastcall GetActiveLabeledEdit();

public:		// [U[錾
	TCursor crSpuitTool;
	TCursor crHandGrabR;

	UnicodeString ExePath;		//NyanFiNpX

	UnicodeString CurFileName;	//J[\ʒũt@C
	UnicodeString CurPathName;	//݂̃JgpX
	UnicodeString OppPathName;	//݂̔΃pX

	TStringList *RefRegExList;	//K\̊ȈՐXg

	TRect FileListRect;			//t@CXg̃XN[WRect

	__fastcall TUserModule(TComponent* Owner);

	void __fastcall InitializeListBox(TCustomListBox *lp, UsrScrollPanel *sp = NULL);
	void __fastcall UninitializeListBox();

	bool __fastcall ListBoxOpeItem(UnicodeString keystr);

	void __fastcall BeginSpuit(TPanel *pp, TImage *ip = NULL);
	TColor __fastcall EndSpuit();
	bool __fastcall SpuitEnabled();

	bool __fastcall ShowPopupMenu();

	void __fastcall SetOpenImgFilter(UnicodeString fnam);
	bool __fastcall SelectDirEx(_TCHAR *tit, UnicodeString &dnam, bool to_rel = false);

	UnicodeString __fastcall get_DlgDefExt(UnicodeString filter);
	void __fastcall PrepareOpenDlg(_TCHAR *tit, _TCHAR *filter, _TCHAR *fnam = NULL, UnicodeString inidir = EmptyStr);
	void __fastcall PrepareSaveDlg(_TCHAR *tit, _TCHAR *filter, _TCHAR *fnam = NULL, UnicodeString inidir = EmptyStr);

	bool __fastcall OpenDlgToEdit(TWinControl *ep, bool to_rel = false);
	bool __fastcall OpenDlgToStr(UnicodeString &s, bool to_rel = false);
	bool __fastcall OpenImgDlgToEdit(TWinControl *ep, bool to_rel = false);
	bool __fastcall FontDlgToFont(TFont *f);
};
//---------------------------------------------------------------------------
extern PACKAGE TUserModule *UserModule;
//---------------------------------------------------------------------------
#endif
